from typing import List
from tkinter import Menu

from models.CommandProps import CommandProps


class ControllerDesign:
    def __init__(self, master):
        self.background = "black"

        self.master = master
        self.menubar = Menu(self.master)

    def init_menu_dropdown(self, label, commands: List[CommandProps]):
        file_menu = Menu(self.menubar, tearoff=0)
        for command in commands:
            file_menu.add_command(label=command.label, command=command.command)
        self.menubar.add_cascade(label=label, menu=file_menu)
        self.master.config(menu=self.menubar)
