class ComponentPanelLogs extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            isOpened: !!props.isOpened,
            logs: this.props.logs
        };

        document.addEventListener(UPDATE_STATE_LOGS, this.updateStateLogs);
    }

    updateStateLogs = (event) => {
        try {
            this.setState({
                logs: event.detail.logs
            });

            let jEl = $("#panel-logs-content");
            if(jEl.length) {
                jEl.animate({
                    scrollTop: jEl.prop("scrollHeight")
                }, 500);
            }
        } catch (e) {
            alert(e.message);
        }
    }

    componentDidMount = () => {
        this.scrollToBottom();
    }

    scrollToBottom = () => {
        try {
            let jEl = $("#panel-logs-content");
            if(jEl.length) {
                jEl[0].scrollTop = jEl[0].scrollHeight;
            }
        } catch (e) {
            alert(e.message);
        }
    }

    onTogglePanel = () => {
        try {
            this.setState({
                isOpened: !this.state.isOpened
            });

            if (this.props.onTogglePanel) {
                setTimeout(() => {
                    this.props.onTogglePanel();
                    if(this.state.isOpened) {
                        this.scrollToBottom();
                    }
                }, 1);
            }
        } catch (e) {
            console.log(e);
        }
    }

    render = () => {
        return (
            <div id="panel-logs">
                <div id="panel-logs-tabs">
                    <Tab
                        label="Log"
                        className={this.state.isOpened ? "active" : ""}
                        onClick={this.onTogglePanel}
                    />
                </div>
                {this.state.isOpened &&
                    <div id="panel-logs-content">
                        {this.state.logs.map(it =>
                        <div key={`log-${it.timestamp_unix}-${Math.random()}`}><span className="span-date">{(new Date(it.timestamp_unix * 1000)).toISOString().slice(0, 19)}</span>
                            <span className="span-source">{it.source}</span>
                            <span className="span-message">{it.message}</span>
                        </div>)}
                    </div>}
            </div>);
    }
}


