class ComponentPanelPOIs extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
        };
    }

    onSavePOI = () => {
        let poi_label = prompt('Enter label of POI:').trim();
        if (poi_label.length) {
            document.dispatchEvent(new CustomEvent(POI_SAVE_ACTIVE, { detail: poi_label }));
        }
    }

    onDeletePOI = () => {
        document.dispatchEvent(new CustomEvent(POI_DELETE_ACTIVE, { detail: {} }));
    }

    onClearAllPOIs = () => {
        if(confirm('Are you sure you want to delete all POIs?')) {
            document.dispatchEvent(new CustomEvent(POI_DELETE_ALL, { detail: {} }));
        }
    }

    onAdcFlyToPOI = () => {
        document.dispatchEvent(new CustomEvent(POI_FLY_TO_ACTIVE, { detail: {} }));
    }

    componentDidMount = () => {
    }

    render = () => {
        return (
            <div id="panel-poi-side">
                <FormControlLabel
                    control={<Checkbox
                        checked={this.props.isSnapToFlightPath}
                        onChange={(event) => {
                            this.props.onSnapToFlightPathChange(event);
                        }}
                    />}
                    label="Snap to flight path"/>

                <Button variant="contained" style={{marginBottom: 10}} onClick={this.onSavePOI}>Save selected
                    POI</Button>
                <Button variant="contained" style={{marginBottom: 10}} onClick={this.onDeletePOI}>Delete selected
                    POI</Button> &nbsp;
                <Button variant="contained" style={{marginBottom: 10}} onClick={this.onClearAllPOIs}>Clear all</Button>
                <Button variant="contained" style={{marginBottom: 10}} onClick={this.onAdcFlyToPOI}>Fly to selected
                    POI</Button>
                <div className="clear"></div>
                <span className="span-info">* Double click to select or add new POI</span>
            </div>);
    }
}


