class DialogLoadPLYandTXT extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      filePathPLY: '',
      filePathTXT: '',
      isLoading: false
    };

  }

  onClose = () => {
    this.setState({
      filePathPLY: '',
      filePathTXT: '',
      isLoading: false
    });
    this.props.onClose();
  }

  onOpenPLY = async () => {
    let filePathPLY = await eel.open_filepath_ply()();
    this.setState({
      filePathPLY: filePathPLY
    });
  }

  onOpenTXT = async () => {
    let filePathTXT = await eel.open_filepath_txt()();
    this.setState({
      filePathTXT: filePathTXT
    });
  }

  onOk = async () => {
    try {
        if(this.state.isLoading) {
          return;
        }
        if(this.state.filePathPLY.length > 0 && this.state.filePathTXT.length > 0) {
          this.setState({
            isLoading: true
          });
          let result = await eel.load_ply_and_txt()()
          if(result === '') {
            this.onClose();
          } else {
            alert(result);
            this.setState({
              isLoading: false
            });
          }
        }
        else {
          alert('Please select PLY and TXT file')
        }
    }
    catch (e) {
      alert(e);
      this.setState({
        isLoading: false
      });
    }
  }

  render = () => {
    const style = {
      position: 'absolute',
      top: '50%',
      left: '50%',
      transform: 'translate(-50%, -50%)',
      width: 400,
      bgcolor: 'background.paper',
      border: '2px solid #000',
      boxShadow: 24,
      p: 4,
    };

    return (
    <Modal
      open={this.props.isOpen}
      onClose={this.onClose}
    >
      <Box sx={style}>
        <Button variant="contained" style={{marginBottom: 10}} onClick = {this.onOpenPLY}>Load PLY file..</Button><br/>
        <span>{this.state.filePathPLY}</span><br />

        <Button variant="contained" onClick = {this.onOpenTXT}>Load TXT file..</Button><br/>
        <span>{this.state.filePathTXT}</span><br/>
        {this.state.isLoading && <div>
          <span>Loading..</span>
          <LinearProgress />
        </div>}
        <Button variant="contained" style={{marginRight: 10}} onClick={this.onClose}>Cancel</Button>
        <Button variant="contained" onClick={this.onOk}>Ok</Button>
      </Box>
    </Modal>);
  }
}


